/*
 * wnix, a Unix-like operating system for WebAssembly applications.
 * Copyright (C) 2025  Xavier Del Campo Romero
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <https://www.gnu.org/licenses/>.
 */

#include <bin.h>
#include <bin/proc.h>
#include <bin/types.h>
#include <aio.h>
#include <caio.h>
#include <stdlib.h>

void bin_proc_free(struct bin_proc *const p)
{
    if (!p)
        return;

    struct bin_dbg *const d = &p->dbg;

    for (char **arg = p->argv; *arg; arg++)
        free(*arg);

    dynstr_free(&d->dstr);
    free(d->bkpt);
    aio_free(d->aio);
    caio_close(p->caio);
    free(p->global.buf);
    free(p->path);
    free(p);
}
